#version 450 core

layout(location = 0) out vec4 color;

struct VertexOutput {
  vec4 Position;
  vec4 Color;
  vec2 TexCoord;
  vec3 Normal;
};

layout(location = 0) in VertexOutput Input;

layout(set = 1, binding = 0) uniform sampler2D tex;

void main() {
  float a = texture(tex, Input.TexCoord.xy).r;
  color = vec4(Input.Color.rgb, Input.Color.a * a);
  if (color.a < 0.5)
    discard;
}
