#version 450 core

layout(location = 0) in vec3 inPosition;
layout(location = 1) in vec3 inNormal;
layout(location = 2) in vec2 inTexCoord;

layout(std140, binding = 0) uniform VP { mat4 view[2]; mat4 project[2]; uint viewIndex; };
layout(std140, binding = 1) uniform Model { mat4 model; };
layout(std140, binding = 2) uniform Color { vec4 tintColor; };

struct VertexOutput {
  vec4 Color;
  vec2 TexCoord;
  vec3 Normal;
};

layout(location = 0) out VertexOutput Output;

void main() {
  mat4 viewProjection = project[viewIndex] * view[viewIndex];

  Output.Color = tintColor;
  Output.Normal = inNormal;
  Output.TexCoord = inTexCoord;
  gl_Position = viewProjection * model * vec4(inPosition, 1.0);
}
